: poor man's mfactor multithreading Windows batch script, since there's no multithread build choice for mfactor on Windows currently (2020).
: This launches "threads" number of single-core executables with adjacent subsets of passes assigned to each,
: via the subordinate separate batch script factorsub. Test config first, then uncomment the exe line in factorsub.
: Note, for this file, threads must be a factor of passes: 1, 2, 4, 8, 16 for passes=16;
:	or for passes=960:	1,2,3,4,5,6,8,10,12,15,16,20,24,30,32,40,48,60,64,80,96,120,160,192,240,320,480,960
: set passes = 16 for ordinary mfactor; set passes = 960 = 2^6 * 3 * 5 for TF_CLASSES=4620 defined builds
: Threads should probably not exceed the number of cores or hyperthreads available, 
:   or half the number of windows you're willing to deal with closing later; there's a command prompt and a log file that will display for each thread.
: Note, one can switch from single threading to multithreading part way. Example; had just started pass # 30 single threaded.
: Stop that process, switch to multithreading, modify a=0 below to a=1 will skip the first "span" (the number of passes per thread).
: Then if threads= 32, passes=960, initial a=1, span = 30, thread #0 that would redo passes 0-29 gets skipped.
: The other "threads" get launched from #1 which gets passes 30 to 59, up through #31 which gets passes 30*31=930 to 30*32-1 = 959.
: That worked well on a 16-core +hyperthread-enabled machine. Parallelism speedup was ~80% of ideal with hyperthreading.
: The separate log files for each thread get named m<exponent>-<bmax>-<passmin-for-that-thread>.txt
: and also for saving possible k values to resume from, and any other stderr output, m<exponent>-<bmax>-<passmin-for-that-thread>.err.txt
: These are specific to Mersenne numbers; change -m in factorsub to -f or -mm for Fermats or double-mersennes respectively;
: change m to mm or f for log file names in factorsub and below.
:
: before attempting any multithreading runs, test with single-threading that mfactor is operating correctly on your system!
: finding one or more of the known factors of mm31 can be a useful test
:
: Note that run times can be very long for high (tf bit level) / log2(exponent) 
: Also, there's lots of reference here to threads above, but really they are separate processes.

set enableextensions

:estimated optimal bits TF per cpu TF, gpu TF vs bits exponent, asymptotic, +2 bits/doubling
: exp bits  cpu	gpu
:	30   82  87
:	31   85  89
:	32   88	 91
:	34   92	 95
:	36   96  99
:	40  100 103
:	42  104 107
:	50  120 123
:	60  140 143
:	66  152 155
:	67  154 157
:	76  172 175
:      127  274 277

: The following goto selects among several exponents under test. This can be convenient if doing multithreaded runs on several exponents and systems
: See also https://www.mersenneforum.org/showpost.php?p=512904&postcount=5 re the 66, 67, and 76 bit exponents below.

goto m36b

:set any of the following for your desired executable, exponent, and parameters. These indicate next undone bit level for each

:m66b
:see https://www.mersenneforum.org/showpost.php?p=429233&postcount=4 for origin
set exponent=71324207525210468041
set bmin=117
set bmax=118
goto threads

:m67b
: see https://www.mersenneforum.org/showthread.php?t=17050 for origin
set exponent=97600541752017987211
set bmin=117
set bmax=118
goto threads

:m76b
:see https://mersenneforum.org/showpost.php?p=546306&postcount=10 for origin
set exponent=70237298350549551468899
set bmin=125
set bmax=126
goto threads

:m42b
:exponent surfaced as cofactor of a k in https://www.mersenneforum.org/showpost.php?p=548641&postcount=29
set exponent=4099311433391
:estimated cpu-optimal bmax = 104, gpu-optimal ~107 but no software for such a large exponent on gpus yet
set bmin=91
set bmax=92
goto threads

:m36b
:see https://www.mersenneforum.org/showthread.php?t=24539 and https://www.mersenneforum.org/showpost.php?p=551554&postcount=81
set exponent=60651732991
:estimated cpu-optimal bmax=96, gpu-optimal ~99 but no software for such a large exponent on gpus yet
set bmin=86
set bmax=87

:note:  use MMFF on CUDA gpus for MM up to 127 for much more speed
: 	use mfaktc or mfakto for m < 2^32 on gpus for the same reason
:	use Factor5 on exponents or bit levels too large for Mfactor, if you must run such monsters
:	additional background is available in the MFactor reference thread at https://www.mersenneforum.org/showthread.php?p=564633#post564633

:threads
set threads=64
:set passes=16
set passes=960
set /A span=%passes%/%threads%
set exe=mfactor-base-2w-tfc
:change the 0 in the following line if continuing from a partial single-threaded run that completed some passes already
set /A a=0

:----------------------------------------------------------------

set

echo at %date% %time% %exe% -m %exponent% -bmin %bmin% -bmax %bmax% >>%exponent%.txt

:loop
  echo a is %a%  
  set /A passmin=%a% * %span% 
  echo passmin %passmin% 
  set /A passmax=%passmin% + %span% -1 
  echo at %date% %time% start cmd /k factorsub %exe% %exponent% %bmin% %bmax% %passmin% %passmax >>m%exponent%.txt  
: comment out the following line for an echo-only test run after editing exponent-specific or threads sections above, then reenable after a correct test-run to make the real run
  start cmd /k factorsub %exe% %exponent% %bmin% %bmax% %passmin% %passmax% 
  set /A a=%a% + 1
  timeout /T 1
if %a% LSS %threads% goto loop

@echo check each launched thread's command window upon its completion, for signs of a factor, or error messages, before closing